filesize=0

fn openbinfile filename filetype=
(
	binfile=fopen filename filetype
	fseek binfile 0 #seek_end
	filesize=ftell binfile 
	fseek binfile 0 #seek_set
	return binfile
)

fn binend binfile=(ftell binfile>=filesize)

fn freadbyte bf =(return readbyte bf #unsigned)

fn freadint bf =((readbyte bf #unsigned * 256)+(readbyte bf #unsigned))

fn freadlong bf =(((readbyte bf #unsigned) * 16777216)+((readbyte bf #unsigned) * 65536)+((readbyte bf #unsigned) * 256)+(readbyte bf #unsigned))

fn freadfloat bf =
(
	v1=readbyte bf
	v2=readbyte bf
	v3=readbyte bf
	v4=readbyte bf
	tempbf=fopen "c:\\temp.bin" "wb"
	writebyte tempbf v4
	writebyte tempbf v3
	writebyte tempbf v2
	writebyte tempbf v1
	fclose tempbf
	tempbf=fopen "c:\\temp.bin" "rb"
	retval=readfloat tempbf
	fclose tempbf
	return retval
)

fn freadstring bf =
(
	return readstring bf
)

fn freadhead bf =
(
	val=0
	for i=1 to 16 do
	(
		val=val+(readbyte bf #unsigned)
	)
	return val
)

fn freadchunk bf =
(
	val=freadlong bf
	freadlong bf
	return val
)

fn freadoname bf =
(
	cap=freadint bf
	n=freadstring bf
	return n
)

fn readvlst bf =
(
	count=freadlong bf
	val=#()
	for i=1 to count do
	(
		x=freadfloat bf
		y=freadfloat bf
		z=freadfloat bf
		append val [-x*5.2,z*5.2,y*5.2]
	)
	return val
)

fn readtvlst bf =
(
	count=freadlong bf
	val=#()
	for i=1 to count do
	(
		u=freadfloat bf
		v=freadfloat bf
		append val [u,-v,0]
	)
	return val
)

fn readflst bf =
(
	count=freadlong bf
	val=#()
	for i=1 to count do
	(
		a=freadint bf
		b=freadint bf
		c=freadint bf
		d=freadint bf
		e=freadbyte bf
		append val [a+1,b+1,c+1]
	)
	return val
)

fn readmlst bf =
(
	count=freadlong bf
	val=#()
	for i=1 to count do
	(
		append val (readstring bf)
	)
	return val
)

fn readmid bf =
(
	count=freadlong bf
	val=#()
	freadlong bf
	for i=1 to count do
	(
		append val (freadint bf)
	)
	return val
)

rollout Cntr "Convert DAT"
(
	button btn "Go!" width:150
	button typ "tga" widht:150

on btn pressed do
(
max modify mode

fnm=getopenfilename types:"Data files(*.dat)|*.dat"
if (fnm!=undefined)do
(
	fp=getfilenamepath fnm
	fm=getfilenamefile fnm
	fe=getfilenametype fnm
	tp=fp+"tiffrgb\\"
	mln=fp+fm+".MAT"
	
	m1=#()
	m2=#()
	bf=openbinfile mln "rb"
	freadhead bf
	do
	(
		chunk=freadchunk bf
		if chunk!=0 do
		(
			freadhead bf
			freadhead bf
			freadhead bf
			freadhead bf
			freadbyte bf
			append m1 (freadstring bf)
			freadchunk bf
			append m2 (freadstring bf)
			freadchunk bf
		)
	)while binend bf == false
	fclose bf
	
	
	bf=openbinfile fnm "rb"
	head=freadhead bf
	if (head == 484) do
	(
		do
		(
			chunk=1
			do
			(
				chunk=freadchunk bf
				--format "pos:%, chunk:%  \n" (ftell bf) chunk

				if chunk==54 do oname=freadoname bf
				if chunk==23 do vlst=readvlst bf
				if chunk==24 do tvlst=readtvlst bf
				if chunk==53 do flst=readflst bf
				if chunk==22 do mlst=readmlst bf
				if chunk==26 do mid=readmid bf
			)while chunk != 0

			
			if vlst==undefined do vlst=#()
			if flst==undefined do flst=#()
			if tvlst==undefined do tvlst=#()
			if mlst==undefined then mlst=#()
			if mid==undefined do
			(
				mid=#()
				for i=1 to flst.count do
				(
					append mid 1
				)
			)
			o=mesh vertices:vlst faces:flst materialids:mid name:oname
			addmodifier o (uvwmap())
			converttomesh o
			setmesh o tverts:tvlst
			addmodifier o (smooth())
			converttomesh o
			update o
			x=mlst.count
			for i=1 to mlst.count do
			(
				c=mlst.count+1-i
				o1=copy o
				select o1
				update o1
				--o1.name=uniquename o.name
				mm=standard()
				b=bitmaptex filename:(tp+m2[finditem m1 mlst[c]]+"."+typ.caption)
				mm.diffusemap=b
				o1.material=mm
				showtexturemap mm mm.diffusemap on
				y=getnumfaces o1
				for j=1 to y do
				(
					d=y+1-j
					if getfacematid o1 (d) != (c) do deleteface o1 (d)
				)
				meshops.removeisolatedverts o1
			)
		delete o
		--	vlst=#()
		--	flst=#()
		--	mid=#()
		--	tvlst=#()
		)while binend bf == false
	)
	fclose bf
	max select all
)
)
on typ pressed do
(
x=typ.caption

typ.caption="tga"
if x=="tga" do typ.caption="tif"
)
)

if datconverter != undefined then closeRolloutFloater datconverter

datconverter=newrolloutfloater "Convert DAT 7.0" 200 200
addrollout Cntr datconverter rolledup:false
